#
# users.py
# cs150 Spring 2007
#

import db
import MySQLdb
import md5crypt
import random

class Users:
   def __init__(self):
      self.db = MySQLdb.connect (db.server, db.username, db.password, db.dbName)
      self.currentUser = False

   def __del__(self):
      try:
         self.close () 
      except: 
         print "Database closed"

   def close(self):
      self.db.commit ()
      self.db.close ()

   def setCurrentUser(self, user):
      self.currentUser = user

   def getCurrentUser(self):
      return self.currentUser

   def allUsers(self):
      c = self.db.cursor ()
      c.execute ("SELECT * FROM users")
      return c.fetchall ()

   def hasUser(self, user):
      c = self.db.cursor ()
      query = "SELECT user FROM users WHERE user='" + user + "'"
      c.execute (query)
      if len (c.fetchall ()) == 1:
         return True
      else:
         return False

   def hasEmail(self, email):
      c = self.db.cursor ()
      query = "SELECT user FROM users WHERE email='" + email + "'"
      c.execute (query)
      if len (c.fetchall ()) > 0:
         return True
      else:
         return False

   def lookupUser(self, user):
      try:
         c = self.db.cursor ()
         query = "SELECT * FROM users WHERE user='" + user + "'"
         c.execute (query)
         return c.fetchone ()
      except:
         return None
      
   def lookupByEmail(self, email):
      try:
         c = self.db.cursor ()
         query = "SELECT user FROM users WHERE email='" + email + "'"
         c.execute (query)
         res = c.fetchone ()
         return res[0]
      except:
         return None

   def lookupEmail(self, user):
      try:
         c = self.db.cursor ()
         query = "SELECT email FROM users WHERE user='" + user + "'"
         c.execute (query)
         res = c.fetchone ()
         return res[0]
      except:
         return None

   def lookupPrintName(self, user):
      try:
         c = self.db.cursor ()
         query = "SELECT firstnames, lastname FROM users WHERE user='" + \
                 user + "'"
         c.execute (query)
         res = c.fetchone ()
         pname = res[0] + "&nbsp;" + res[1]
         return pname
      except:
         print "Error in lookupPrintName"
         return user

   def insertUser(self, user, email, lastname, firstnames):
      c = self.db.cursor ()
      query = "INSERT INTO users (user, email, lastname, firstnames) " \
	" VALUES ('" + user + "', '" + email + "', '" + lastname \
	+ "', '" + firstnames + "')"
      try:
         c.execute (query)
         self.db.commit ()
         return True
      except:
         print "Error inserting: " + user
         return False

   def getCookieCount(self, user):
      c = self.db.cursor ()
      query = "SELECT cookiecounter FROM users WHERE user='" + \
              user + "'"
      c.execute (query)
      res = c.fetchone ()
      ccount = res[0]
      return ccount

   def getNextCookieCount(self, user):
      ccount = self.getCookieCount (user)
      cnext = ccount + 1
      c = self.db.cursor ()
      query = "UPDATE users SET cookiecounter='" + str(cnext) \
              + "' WHERE user='" + user + "'"
      c.execute (query)
      self.db.commit ()
      return cnext

   def createUser(self, user, email, firstnames, lastname, password) :
      c = self.db.cursor ()
      encpwd = md5crypt.encrypt (password, user)
      ccount = random.randint (0, 9999999)
      query = "INSERT INTO users (user, email, firstnames, lastname, password, cookiecounter) " \
         	+ "VALUES ('" + user + "', '" + email + "', '" \
                + firstnames + "', '" + lastname + "', '" \
	 	+ encpwd + "', '" + str(ccount) + "')"
      try:
         c.execute (query)
         self.db.commit ()
         return True
      except:
         print "Error creating user: " + user
         return False

   def updatePassword(self, user, password):
      c = self.db.cursor ()
      encpwd = md5crypt.encrypt (password, user)
      ccount = random.randint (0, 9999999)
      query = "UPDATE users SET password='" + encpwd \
	+ "', cookiecounter='" + str(ccount) + "' WHERE user='" \
        + user + "'"
      try:
         c.execute (query)
         self.db.commit ()
         return True
      except:
         print "Error updating password: " + user
         return False

   def checkPassword(self, user, password):
      return True
      c = self.db.cursor ()
      query = "SELECT password FROM users WHERE user='" + user + "'"
      c.execute (query)
      pwd = c.fetchone ()[0]
      if not pwd:
         return False
      else:
         encpwd = md5crypt.encrypt (password, user)
         if encpwd == pwd:
            return True
         else:
            return False

# A global name for the user table (should probably be a class variable instead)
userTable = Users()

def getCurrentUser():
   return userTable.getCurrentUser()

   




